/**
*
*/
import RTIcap.*;
import npacrti.*;

/*
* Defines the RTI Services 
*/
public class 
RTIServices extends _RTIServicesInterfaceImplBase implements RTIDebug
{
    ObjectClassNaming objNaming;
    InteractionNaming interNaming;
    SpaceNaming       spaceNaming;

    public 
    RTIServices(ObjectClassNaming _objNaming, InteractionNaming _interNaming)
    {
       objNaming = _objNaming;
       interNaming = _interNaming;
    }

    /**
    * returns the Object Id of the particular Object Name
    */
    public
    short getObjectClassHandle(String theName)
          throws RTIcap.NameNotFound, RTIcap.FederateNotExecutionMember, 
                 RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                 RTIcap.Deadlock
    {
       return objNaming.getObjectClassHandle(theName);
    }

    /**
    */
    public
    String getObjectClassName(short theHandle)
           throws RTIcap.ObjectClassNotDefined, 
                  RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
    {
       return objNaming.getObjectClassName(theHandle);
    } 

    /**
    */
    public
    short getAttributeHandle(String theName, short whichClass)
          throws RTIcap.ObjectClassNotDefined, RTIcap.NameNotFound, 
                 RTIcap.FederateNotExecutionMember, 
                 RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                 RTIcap.Deadlock
    {
       return objNaming.getAttributeHandle(theName,whichClass);
    }

    /**
    */
    public
    String getAttributeName(short theHandle, short whichClass)
           throws RTIcap.ObjectClassNotDefined, RTIcap.AttributeNotDefined, 
                  RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
    {
       return objNaming.getAttributeName(theHandle,whichClass);
    }

    /**
    */
    public
    short getInteractionClassHandle(String theName)
          throws RTIcap.NameNotFound, RTIcap.FederateNotExecutionMember, 
                 RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                 RTIcap.Deadlock
    {
       return interNaming.getInteractionClassHandle(theName);
    }

    /**
    */
    public
    String getInteractionClassName(short theHandle)
           throws RTIcap.InteractionClassNotDefined, 
                  RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
    {
       return interNaming.getInteractionClassName(theHandle);
    }

    /**
    */
    public
    short getParameterHandle(String theName, short whichClass)
          throws RTIcap.InteractionClassNotDefined, RTIcap.NameNotFound, 
                 RTIcap.FederateNotExecutionMember, 
                 RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                 RTIcap.Deadlock
    {
       return interNaming.getParameterHandle(theName,whichClass);
    }

    /**
    */
    public
    String getParameterName(short theHandle, short whichClass)
           throws RTIcap.InteractionClassNotDefined, 
                  RTIcap.InteractionParameterNotDefined, 
                  RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
    {
       return interNaming.getParameterName(theHandle,whichClass);
    }

    /**
    */
    public
    int getSpaceHandle(String theName)
        throws RTIcap.NameNotFound, RTIcap.FederateNotExecutionMember, 
               RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
               RTIcap.Deadlock, RTIcap.UnimplementedService
    {
       return spaceNaming.getSpaceHandle(theName);
    }

    /**
    */
    public
    String getSpaceName(int theHandle)
           throws RTIcap.SpaceNotDefined, RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock, RTIcap.UnimplementedService
    {
       return spaceNaming.getSpaceName(theHandle);
    }

    /**
    */
    public
    short getFederateHandle(String theName)
          throws RTIcap.FederateDoesNotExist, RTIcap.FederateNotExecutionMember, 
                 RTIcap.ConcurrentAccessAttempted, 
                 RTIcap.RTIinternalError, RTIcap.Deadlock, 
                 RTIcap.UnimplementedService
    {
        short ret=0;
        
        return ret;
    }

    /**
    */
    public
    String getFederateName(short theHandle)
           throws RTIcap.FederateDoesNotExist, 
                  RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, 
                  RTIcap.RTIinternalError, RTIcap.Deadlock, 
                  RTIcap.UnimplementedService
    {
       String ret = null;

       return ret;
    }

    /**
    */
    public
    void turnRegulationOn()
         throws RTIcap.FederationTimeAlreadyPassed, 
                RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }
 

    /**
    */
    public
    double turnRegulationOnNow()
           throws RTIcap.FederateNotExecutionMember, 
                  RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                  RTIcap.Deadlock
    {
       double ret=0;

       return ret;
    }

    /**
    */
    public
    void turnRegulationOff()
         throws RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

    /**
    */
    public
    void setTimeConstrained(RTIcap._Boolean state)
         throws RTIcap.FederateNotExecutionMember, 
                RTIcap.ConcurrentAccessAttempted, RTIcap.RTIinternalError, 
                RTIcap.Deadlock
    {
    }

}// end of RTIAmb
